---
type: api
title: Preview a transform
description: Generates a preview of the results that you will get when you create a transform with the same configuration.
url: https://www.elastic.co/docs/api/doc/elasticsearch-serverless/operation/operation-transform-preview-transform
resource: https://www.elastic.co/docs/api/doc/elasticsearch-serverless/operation/operation-transform-preview-transform
products:
  - Elasticsearch Serverless
---

# Preview a transform

Authentication: required

## Paths

- `POST` (also `GET`) `/_transform/{transform_id}/_preview`
- `POST` (also `GET`) `/_transform/_preview`

#### Path parameters

- `transform_id` (string) — optional, leave it out to use `/_transform/_preview`
  Identifier for the transform to preview. If you specify this path parameter, you cannot provide transform
configuration details in the request body.

## Description

Generates a preview of the results that you will get when you create a transform with the same configuration.

It returns a maximum of 100 results. The calculations are based on all the current data in the source index. It also
generates a list of mappings and settings for the destination index. These values are determined based on the field
types of the source index and the transform aggregations.

## Required privileges

- Index privileges: `read`, `view_index_metadata`
- Cluster privileges: `manage_transform`

## Query string parameters

- `timeout` (union oneOf · default: 30s) — optional
  Period to wait for a response. If no response is received before the
timeout expires, the request fails and returns an error.
  Values: `-1`, `0`

## Request body

`application/json`

- `dest` (object) — optional
  The destination for the transform.
  - `index` (string) — optional
    The destination index for the transform. The mappings of the destination index are deduced based on the source
fields when possible. If alternate mappings are required, use the create index API prior to starting the
transform.
  - `aliases` (object[]) — optional
    The aliases that the destination index for the transform should have.
Aliases are manipulated using the stored credentials of the transform, which means the secondary credentials
supplied at creation time (if both primary and secondary credentials are specified).

The destination index is added to the aliases regardless of whether the destination index was created by the
transform or pre-created by the user.
    - `alias` (string) — required
      The name of the alias.
    - `move_on_creation` (boolean · default: false) — optional
      Whether the destination index should be the only index in this alias.
If `true`, all the other indices will be removed from this alias before adding the destination index to this
alias. This does not delete the removed indices; it only removes them from the alias.
  - `pipeline` (string) — optional
    The unique identifier for an ingest pipeline.
- `description` (string) — optional
  Free text description of the transform.
- `frequency` (union oneOf · default: 1m) — optional
  The interval between checks for changes in the source indices when the
transform is running continuously. Also determines the retry interval in
the event of transient failures while the transform is searching or
indexing. The minimum value is 1s and the maximum is 1h.
  Values: `-1`, `0`
- `pivot` (object) — optional
  The pivot method transforms the data by aggregating and grouping it.
These objects define the group by fields and the aggregation to reduce
the data.
  - `aggregations` (map string to {} Aggregation) — optional
    Defines how to aggregate the grouped data. The following aggregations are currently supported: average, bucket
script, bucket selector, cardinality, filter, geo bounds, geo centroid, geo line, max, median absolute deviation,
min, missing, percentiles, rare terms, scripted metric, stats, sum, terms, top metrics, value count, weighted
average.
    See [Aggregation](https://www.elastic.co/docs/api/doc/elasticsearch-serverless/types/_types-aggregations-aggregationcontainer)
  - `group_by` (map string to object) — optional
    Defines how to group the data. More than one grouping can be defined per pivot. The following groupings are
currently supported: date histogram, geotile grid, histogram, terms.
    Map values (object · min properties: 1 · max properties: 1)
    - `date_histogram` (object) — optional
      - `calendar_interval` (enum) — optional
        Calendar-aware interval.
Can be specified using the unit name, such as `month`, or as a single unit quantity, such as `1M`.
        Values: `second`, `1s`, `minute`, `1m`, `hour`, `1h`, `day`, `1d`, `week`, `1w`, `month`, `1M`, `quarter`, `1q`, `year`, `1y`
      - `extended_bounds` (object) — optional
        Enables extending the bounds of the histogram beyond the data itself.
        - `max` (union oneOf) — optional
          Maximum value for the bound.
          One of: `string` or `number`
        - `min` (union oneOf) — optional
          Minimum value for the bound.
          One of: `string` or `number`
      - `hard_bounds` (object) — optional
        Limits the histogram to specified bounds.
        - `max` (union oneOf) — optional
          Maximum value for the bound.
          One of: `string` or `number`
        - `min` (union oneOf) — optional
          Minimum value for the bound.
          One of: `string` or `number`
      - `field` (string) — optional
        The date field whose values are use to build a histogram.
      - `fixed_interval` (union oneOf) — optional
        Fixed intervals: a fixed number of SI units and never deviate, regardless of where they fall on the calendar.
        Values: `-1`, `0`
      - `format` (string) — optional
        The date format used to format `key_as_string` in the response.
If no `format` is specified, the first date format specified in the field mapping is used.
      - `interval` (union oneOf) — optional — deprecated
        Values: `-1`, `0`
      - `min_doc_count` (number) — optional
        Only returns buckets that have `min_doc_count` number of documents.
By default, all buckets between the first bucket that matches documents and the last one are returned.
      - `missing` (union oneOf) — optional
        The value to apply to documents that do not have a value.
By default, documents without a value are ignored.
        One of: `string` or `number`
      - `offset` (union oneOf) — optional
        Changes the start value of each bucket by the specified positive (`+`) or negative offset (`-`) duration.
        Values: `-1`, `0`
      - `order` (union oneOf) — optional
        The sort order of the returned buckets.
        One of: `string to enum[]` or `string to enum`
      - `params` (map string to object) — optional
      - `script` (string) — optional
      - `time_zone` (string) — optional
        Time zone used for bucketing and rounding.
Defaults to Coordinated Universal Time (UTC).
      - `keyed` (boolean) — optional
        Set to `true` to associate a unique string key with each bucket and return the ranges as a hash rather than an array.
    - `geotile_grid` (object) — optional
      - `field` (string) — optional
        Field containing indexed `geo_point` or `geo_shape` values.
If the field contains an array, `geotile_grid` aggregates all array values.
      - `precision` (number · default: 7) — optional
        Integer zoom of the key used to define cells/buckets in the results.
Values outside of the range [0,29] will be rejected.
      - `shard_size` (number) — optional
        Allows for more accurate counting of the top cells returned in the final result the aggregation.
Defaults to returning `max(10,(size x number-of-shards))` buckets from each shard.
      - `size` (number · default: 10000) — optional
        The maximum number of buckets to return.
      - `bounds` (union oneOf) — optional
        A bounding box to filter the geo-points or geo-shapes in each bucket.
        - **CoordsGeoBounds**
          - `top` (number) — required
          - `bottom` (number) — required
          - `left` (number) — required
          - `right` (number) — required
        - **TopLeftBottomRightGeoBounds**
          - `top_left` (union oneOf) — required
            - **LatLonGeoLocation**
              - `lat` (number) — required
                Latitude
              - `lon` (number) — required
                Longitude
            - **GeoHashLocation**
              - `geohash` (string) — required
            - **[]number**
            - **string**
          - `bottom_right` (union oneOf) — required
            - **LatLonGeoLocation**
              - `lat` (number) — required
                Latitude
              - `lon` (number) — required
                Longitude
            - **GeoHashLocation**
              - `geohash` (string) — required
            - **[]number**
            - **string**
        - **TopRightBottomLeftGeoBounds**
          - `top_right` (union oneOf) — required
            - **LatLonGeoLocation**
              - `lat` (number) — required
                Latitude
              - `lon` (number) — required
                Longitude
            - **GeoHashLocation**
              - `geohash` (string) — required
            - **[]number**
            - **string**
          - `bottom_left` (union oneOf) — required
            - **LatLonGeoLocation**
              - `lat` (number) — required
                Latitude
              - `lon` (number) — required
                Longitude
            - **GeoHashLocation**
              - `geohash` (string) — required
            - **[]number**
            - **string**
        - **WktGeoBounds**
          - `wkt` (string) — required
    - `histogram` (object) — optional
      - `extended_bounds` (object) — optional
        Enables extending the bounds of the histogram beyond the data itself.
        - `max` (number) — optional
          Maximum value for the bound.
        - `min` (number) — optional
          Minimum value for the bound.
      - `hard_bounds` (object) — optional
        Limits the range of buckets in the histogram.
It is particularly useful in the case of open data ranges that can result in a very large number of buckets.
        - `max` (number) — optional
          Maximum value for the bound.
        - `min` (number) — optional
          Minimum value for the bound.
      - `field` (string) — optional
        The name of the field to aggregate on.
      - `interval` (number) — optional
        The interval for the buckets.
Must be a positive decimal.
      - `min_doc_count` (number) — optional
        Only returns buckets that have `min_doc_count` number of documents.
By default, the response will fill gaps in the histogram with empty buckets.
      - `missing` (number) — optional
        The value to apply to documents that do not have a value.
By default, documents without a value are ignored.
      - `offset` (number) — optional
        By default, the bucket keys start with 0 and then continue in even spaced steps of `interval`.
The bucket boundaries can be shifted by using the `offset` option.
      - `order` (union oneOf) — optional
        The sort order of the returned buckets.
By default, the returned buckets are sorted by their key ascending.
        One of: `string to enum[]` or `string to enum`
      - `script` (string) — optional
      - `format` (string) — optional
      - `keyed` (boolean · default: false) — optional
        If `true`, returns buckets as a hash instead of an array, keyed by the bucket keys.
    - `terms` (object) — optional
      - `collect_mode` (enum) — optional
        Determines how child aggregations should be calculated: breadth-first or depth-first.

Supported values include:
  - `depth_first`: Expands all branches of the aggregation tree in one depth-first pass, before any pruning occurs.
  - `breadth_first`: Caches the set of documents that fall into the uppermost buckets for subsequent replay.
        Values: `depth_first`, `breadth_first`
      - `exclude` (union oneOf) — optional
        Values to exclude.
Accepts regular expressions and partitions.
        One of: `string[]` or `string`
      - `execution_hint` (enum) — optional
        Determines whether the aggregation will use field values directly or global ordinals.
        Values: `map`, `global_ordinals`, `global_ordinals_hash`, `global_ordinals_low_cardinality`
      - `field` (string) — optional
        The field from which to return terms.
      - `include` (union oneOf) — optional
        Values to include.
Accepts regular expressions and partitions.
        - **[]string**
        - **string**
        - **TermsPartition**
          - `num_partitions` (number) — required
            The number of partitions.
          - `partition` (number) — required
            The partition number for this request.
      - `min_doc_count` (number · default: 1) — optional
        Only return values that are found in more than `min_doc_count` hits.
      - `missing` (boolean | number | string) — optional
        The value to apply to documents that do not have a value.
By default, documents without a value are ignored.
      - `missing_order` (enum) — optional
        Values: `first`, `last`, `default`
      - `missing_bucket` (boolean) — optional
      - `value_type` (string) — optional
        Coerced unmapped fields into the specified type.
      - `order` (union oneOf) — optional
        Specifies the sort order of the buckets.
Defaults to sorting by descending document count.
        One of: `string to enum[]` or `string to enum`
      - `script` (string) — optional
      - `shard_min_doc_count` (number) — optional
        Regulates the certainty a shard has if the term should actually be added to the candidate list or not with respect to the `min_doc_count`.
Terms will only be considered if their local shard frequency within the set is higher than the `shard_min_doc_count`.
      - `shard_size` (number) — optional
        The number of candidate terms produced by each shard.
By default, `shard_size` will be automatically estimated based on the number of shards and the `size` parameter.
      - `show_term_doc_count_error` (boolean) — optional
        Set to `true` to return the `doc_count_error_upper_bound`, which is an upper bound to the error on the `doc_count` returned by each shard.
      - `size` (number · default: 10) — optional
        The number of buckets returned out of the overall terms list.
      - `format` (string) — optional
- `source` (object) — optional
  The source of the data for the transform.
  - `index` (union oneOf) — required
    The source indices for the transform. It can be a single index, an index pattern (for example, `"my-index-*""`), an
array of indices (for example, `["my-index-000001", "my-index-000002"]`), or an array of index patterns (for
example, `["my-index-*", "my-other-index-*"]`. For remote indices use the syntax `"remote_name:index_name"`. If
any indices are in remote clusters then the master node and at least one transform node must have the `remote_cluster_client` node role.
    One of: `string[]` or `string`
  - `query` ({} Query) — optional
    A query clause that retrieves a subset of data from the source index.
    See [Query](https://www.elastic.co/docs/api/doc/elasticsearch-serverless/types/_types-query_dsl-querycontainer)
  - `runtime_mappings` (object) — optional
    Definitions of search-time runtime fields that can be used by the transform. For search runtime fields all data
nodes, including remote nodes, must be 7.12 or later.
- `settings` (object) — optional
  Defines optional transform settings.
  - `align_checkpoints` (boolean · default: true) — optional
    Specifies whether the transform checkpoint ranges should be optimized for performance. Such optimization can align
checkpoint ranges with the date histogram interval when date histogram is specified as a group source in the
transform config. As a result, less document updates in the destination index will be performed thus improving
overall performance.
  - `dates_as_epoch_millis` (boolean · default: false) — optional
    Defines if dates in the output should be written as ISO formatted string or as millis since epoch. epoch_millis was
the default for transforms created before version 7.11. For compatible output set this value to `true`.
  - `deduce_mappings` (boolean · default: true) — optional
    Specifies whether the transform should deduce the destination index mappings from the transform configuration.
  - `docs_per_second` (number) — optional
    Specifies a limit on the number of input documents per second. This setting throttles the transform by adding a
wait time between search requests. The default value is null, which disables throttling.
  - `max_page_search_size` (number) — optional
    Defines the initial page size to use for the composite aggregation for each checkpoint. If circuit breaker
exceptions occur, the page size is dynamically adjusted to a lower value. The minimum value is `10` and the
maximum is `65,536`. The default value is `500` for `pivot` transforms and `5000` for `latest` transforms.
  - `use_point_in_time` (boolean · default: true) — optional
    Specifies whether the transform checkpoint will use the Point In Time API while searching over the source index.
In general, Point In Time is an optimization that will reduce pressure on the source index by reducing the amount
of refreshes and merges, but it can be expensive if a large number of Point In Times are opened and closed for a
given index. The benefits and impact depend on the data being searched, the ingest rate into the source index, and
the amount of other consumers searching the same source index.
  - `num_failure_retries` (number) — optional
    Defines the number of retries on a recoverable failure before the transform task is marked as `failed`.
The minimum value is `0` and the maximum is `100`, where `-1` indicates that the transform retries indefinitely.
If unset, the cluster-level setting `num_transform_failure_retries` is used.

This setting cannot be specified when `unattended` is `true`, because unattended transforms always retry
indefinitely.
  - `unattended` (boolean · default: false) — optional
    If `true`, the transform runs in unattended mode. In unattended mode, the transform retries indefinitely in case
of an error which means the transform never fails. Setting the number of retries other than infinite fails in
validation.
  - `indexer_request_timeout` (union string) — optional — nullable
    The initial timeout for the requests the transform sends to nodes to retrieve checkpoint information.
Each consecutive failure doubles the timeout, up to a maximum of `12h`. The minimum value is `1ms` and the
maximum is `12h`. Defaults to `30s`.
    Values: `-1`, `0`
- `sync` (object) — optional
  Defines the properties transforms require to run continuously.
  - `time` (object) — optional
    Specifies that the transform uses a time field to synchronize the source and destination indices.
    - `delay` (union oneOf · default: 60s) — optional
      The time delay between the current time and the latest input data time.
      Values: `-1`, `0`
    - `field` (string) — required
      The date field that is used to identify new documents in the source. In general, it’s a good idea to use a field
that contains the ingest timestamp. If you use a different field, you might need to set the delay such that it
accounts for data transmission delays.
- `retention_policy` (object) — optional
  Defines a retention policy for the transform. Data that meets the defined
criteria is deleted from the destination index.
  - `time` (object) — optional
    Specifies that the transform uses a time field to set the retention policy.
    - `field` (string) — required
      The date field that is used to calculate the age of the document.
    - `max_age` (union oneOf) — required
      Specifies the maximum age of a document in the destination index. Documents that are older than the configured
value are removed from the destination index.
      Values: `-1`, `0`
- `latest` (object) — optional
  The latest method transforms the data by finding the latest document for
each unique key.
  - `sort` (string) — required
    Specifies the date field that is used to identify the latest documents.
  - `unique_key` (string[]) — required
    Specifies an array of one or more fields that are used to group the data.

## Response

`application/json`

- `generated_dest_index` (object)
  - `aliases` (map string to object)
    Map values (object)
    - `filter` ({} Query)
      Query used to limit documents the alias can access.
      See [Query](https://www.elastic.co/docs/api/doc/elasticsearch-serverless/types/_types-query_dsl-querycontainer)
    - `index_routing` (string)
      Value used to route indexing operations to a specific shard.
If specified, this overwrites the `routing` value for indexing operations.
    - `is_hidden` (boolean · default: false)
      If `true`, the alias is hidden.
All indices for the alias must have the same `is_hidden` value.
    - `is_write_index` (boolean · default: false)
      If `true`, the index is the write index for the alias.
    - `routing` (string)
      Value used to route indexing and search operations to a specific shard.
    - `search_routing` (string)
      Value used to route search operations to a specific shard.
If specified, this overwrites the `routing` value for search operations.
  - `mappings` (object)
    - `all_field` (object)
      - `analyzer` (string)
      - `enabled` (boolean)
      - `omit_norms` (boolean)
      - `search_analyzer` (string)
      - `similarity` (string)
      - `store` (boolean)
      - `store_term_vector_offsets` (boolean)
      - `store_term_vector_payloads` (boolean)
      - `store_term_vector_positions` (boolean)
      - `store_term_vectors` (boolean)
    - `date_detection` (boolean)
    - `dynamic` (enum)
      Values: `strict`, `runtime`, `true`, `false`
    - `dynamic_date_formats` (string[])
    - `dynamic_templates` (string to object[])
    - `_field_names` (object)
      - `enabled` (boolean)
    - `index_field` (object)
      - `enabled` (boolean)
    - `_meta` (object)
    - `numeric_detection` (boolean)
    - `properties` (map string to oneOf)
      Map values (union oneOf)
      One of:
      - **type: binary** (`type: binary`)
        - `type` (enum)
          Values: `binary`
        - `meta` (map string to string)
          Metadata about the field.
        - `properties` (map string to oneOf) — recursive
        - `ignore_above` (number)
        - `dynamic` (enum)
          Values: `strict`, `runtime`, `true`, `false`
        - `fields` (map string to oneOf) — recursive
        - `synthetic_source_keep` (enum)
          

Supported values include:
  - `none`: Synthetic source diverges from the original source (default)
  - `arrays`: Arrays of the corresponding field or object preserve the original element ordering and duplicate elements.
The synthetic source fragment for such arrays is not guaranteed to match the original source exactly,
e.g. array [1, 2, [5], [[4, [3]]], 5] may appear as-is or in an equivalent format like [1, 2, 5, 4, 3, 5].
The exact format may change in the future, in an effort to reduce the storage overhead of this option.
  - `all`: The source for both singleton instances and arrays of the corresponding field or object gets recorded.
When applied to objects, the source of all sub-objects and sub-fields gets captured.
Furthermore, the original source of arrays gets captured and appears in synthetic source with no modifications.
          Values: `none`, `arrays`, `all`
        - `copy_to` (union oneOf)
          One of: `string[]` or `string`
        - `store` (boolean)
        - `doc_values` (union oneOf)
          - **boolean**
          - **DocValuesConfig**
            Configuration object for doc values when sub-parameters are needed.
            - `multi_value` (boolean · default: true)
              If `false`, the field is treated as single-valued, enabling optimized storage.
Only has an effect when columnar index mode is active.
            - `nullability` (boolean · default: true)
              If `false`, every document must provide a non-null value for the field: a document that
omits the field, sets it to `null`, or supplies only null values (an empty array or an
all-null array) is rejected at index time.
A field that defines `null_value` is always exempt, since the configured default removes
the absence of a value.
Only has an effect when columnar index mode is active.
      - **type: boolean** (`type: boolean`)
        - `type` (enum)
          Values: `boolean`
        - `meta` (map string to string)
          Metadata about the field.
        - `properties` (map string to oneOf) — recursive
        - `ignore_above` (number)
        - `dynamic` (enum)
          Values: `strict`, `runtime`, `true`, `false`
        - `fields` (map string to oneOf) — recursive
        - `synthetic_source_keep` (enum)
          

Supported values include:
  - `none`: Synthetic source diverges from the original source (default)
  - `arrays`: Arrays of the corresponding field or object preserve the original element ordering and duplicate elements.
The synthetic source fragment for such arrays is not guaranteed to match the original source exactly,
e.g. array [1, 2, [5], [[4, [3]]], 5] may appear as-is or in an equivalent format like [1, 2, 5, 4, 3, 5].
The exact format may change in the future, in an effort to reduce the storage overhead of this option.
  - `all`: The source for both singleton instances and arrays of the corresponding field or object gets recorded.
When applied to objects, the source of all sub-objects and sub-fields gets captured.
Furthermore, the original source of arrays gets captured and appears in synthetic source with no modifications.
          Values: `none`, `arrays`, `all`
        - `copy_to` (union oneOf)
          One of: `string[]` or `string`
        - `store` (boolean)
        - `doc_values` (union oneOf)
          - **boolean**
          - **DocValuesConfig**
            Configuration object for doc values when sub-parameters are needed.
            - `multi_value` (boolean · default: true)
              If `false`, the field is treated as single-valued, enabling optimized storage.
Only has an effect when columnar index mode is active.
            - `nullability` (boolean · default: true)
              If `false`, every document must provide a non-null value for the field: a document that
omits the field, sets it to `null`, or supplies only null values (an empty array or an
all-null array) is rejected at index time.
A field that defines `null_value` is always exempt, since the configured default removes
the absence of a value.
Only has an effect when columnar index mode is active.
        - `boost` (number)
        - `fielddata` (object)
          - `format` (enum)
            Values: `array`, `disabled`
        - `index` (boolean)
        - `null_value` (boolean)
        - `ignore_malformed` (boolean)
        - `script` (string)
        - `on_script_error` (enum)
          Values: `fail`, `continue`
        - `time_series_dimension` (boolean)
          For internal use by Elastic only. Marks the field as a time series dimension. Defaults to false.
      - **type: {dynamic_type}** (`type: {dynamic_type}`)
        - `type` (enum)
          Values: `{dynamic_type}`
        - `meta` (map string to string)
          Metadata about the field.
        - `properties` (map string to oneOf) — recursive
        - `ignore_above` (number)
        - `dynamic` (enum)
          Values: `strict`, `runtime`, `true`, `false`
        - `fields` (map string to oneOf) — recursive
        - `synthetic_source_keep` (enum)
          

Supported values include:
  - `none`: Synthetic source diverges from the original source (default)
  - `arrays`: Arrays of the corresponding field or object preserve the original element ordering and duplicate elements.
The synthetic source fragment for such arrays is not guaranteed to match the original source exactly,
e.g. array [1, 2, [5], [[4, [3]]], 5] may appear as-is or in an equivalent format like [1, 2, 5, 4, 3, 5].
The exact format may change in the future, in an effort to reduce the storage overhead of this option.
  - `all`: The source for both singleton instances and arrays of the corresponding field or object gets recorded.
When applied to objects, the source of all sub-objects and sub-fields gets captured.
Furthermore, the original source of arrays gets captured and appears in synthetic source with no modifications.
          Values: `none`, `arrays`, `all`
        - `copy_to` (union oneOf)
          One of: `string[]` or `string`
        - `store` (boolean)
        - `doc_values` (union oneOf)
          - **boolean**
          - **DocValuesConfig**
            Configuration object for doc values when sub-parameters are needed.
            - `multi_value` (boolean · default: true)
              If `false`, the field is treated as single-valued, enabling optimized storage.
Only has an effect when columnar index mode is active.
            - `nullability` (boolean · default: true)
              If `false`, every document must provide a non-null value for the field: a document that
omits the field, sets it to `null`, or supplies only null values (an empty array or an
all-null array) is rejected at index time.
A field that defines `null_value` is always exempt, since the configured default removes
the absence of a value.
Only has an effect when columnar index mode is active.
        - `enabled` (boolean)
        - `null_value` (union oneOf)
          One of: `number` or `string` or `boolean`
        - `boost` (number)
        - `coerce` (boolean)
        - `script` (string)
        - `on_script_error` (enum)
          Values: `fail`, `continue`
        - `ignore_malformed` (boolean)
        - `time_series_metric` (enum)
          Values: `gauge`, `counter`, `summary`, `histogram`, `position`
        - `time_series_dimension` (boolean)
        - `analyzer` (string)
        - `eager_global_ordinals` (boolean)
        - `fielddata` (boolean)
        - `fielddata_frequency_filter` (object)
          - `max` (number)
          - `min` (number)
          - `min_segment_size` (number)
        - `index` (boolean)
        - `index_options` (enum)
          Values: `docs`, `freqs`, `positions`, `offsets`
        - `index_phrases` (boolean)
        - `index_prefixes` (union oneOf) — nullable
          - **TextIndexPrefixes**
            - `max_chars` (number)
            - `min_chars` (number)
          - **string**
        - `norms` (boolean)
        - `position_increment_gap` (number)
        - `search_analyzer` (string)
        - `search_quote_analyzer` (string)
        - `similarity` (union string) — nullable
          One of: `string`
        - `term_vector` (enum)
          Values: `no`, `yes`, `with_offsets`, `with_positions`, `with_positions_offsets`, `with_positions_offsets_payloads`, `with_positions_payloads`
        - `format` (string)
        - `precision_step` (number)
        - `locale` (string)
        - `subobjects` (enum)
          Values: `true`, `false`
      - **type: join** (`type: join`)
        - `type` (enum)
          Values: `join`
        - `meta` (map string to string)
          Metadata about the field.
        - `properties` (map string to oneOf) — recursive
        - `ignore_above` (number)
        - `dynamic` (enum)
          Values: `strict`, `runtime`, `true`, `false`
        - `fields` (map string to oneOf) — recursive
        - `synthetic_source_keep` (enum)
          

Supported values include:
  - `none`: Synthetic source diverges from the original source (default)
  - `arrays`: Arrays of the corresponding field or object preserve the original element ordering and duplicate elements.
The synthetic source fragment for such arrays is not guaranteed to match the original source exactly,
e.g. array [1, 2, [5], [[4, [3]]], 5] may appear as-is or in an equivalent format like [1, 2, 5, 4, 3, 5].
The exact format may change in the future, in an effort to reduce the storage overhead of this option.
  - `all`: The source for both singleton instances and arrays of the corresponding field or object gets recorded.
When applied to objects, the source of all sub-objects and sub-fields gets captured.
Furthermore, the original source of arrays gets captured and appears in synthetic source with no modifications.
          Values: `none`, `arrays`, `all`
        - `relations` (map string to RelationName | RelationName[])
        - `eager_global_ordinals` (boolean)
      - **type: keyword** (`type: keyword`)
        - `type` (enum)
          Values: `keyword`
        - `meta` (map string to string)
          Metadata about the field.
        - `properties` (map string to oneOf) — recursive
        - `ignore_above` (number)
        - `dynamic` (enum)
          Values: `strict`, `runtime`, `true`, `false`
        - `fields` (map string to oneOf) — recursive
        - `synthetic_source_keep` (enum)
          

Supported values include:
  - `none`: Synthetic source diverges from the original source (default)
  - `arrays`: Arrays of the corresponding field or object preserve the original element ordering and duplicate elements.
The synthetic source fragment for such arrays is not guaranteed to match the original source exactly,
e.g. array [1, 2, [5], [[4, [3]]], 5] may appear as-is or in an equivalent format like [1, 2, 5, 4, 3, 5].
The exact format may change in the future, in an effort to reduce the storage overhead of this option.
  - `all`: The source for both singleton instances and arrays of the corresponding field or object gets recorded.
When applied to objects, the source of all sub-objects and sub-fields gets captured.
Furthermore, the original source of arrays gets captured and appears in synthetic source with no modifications.
          Values: `none`, `arrays`, `all`
        - `copy_to` (union oneOf)
          One of: `string[]` or `string`
        - `store` (boolean)
        - `doc_values` (union oneOf)
          - **boolean**
          - **DocValuesConfig**
            Configuration object for doc values when sub-parameters are needed.
            - `multi_value` (boolean · default: true)
              If `false`, the field is treated as single-valued, enabling optimized storage.
Only has an effect when columnar index mode is active.
            - `nullability` (boolean · default: true)
              If `false`, every document must provide a non-null value for the field: a document that
omits the field, sets it to `null`, or supplies only null values (an empty array or an
all-null array) is rejected at index time.
A field that defines `null_value` is always exempt, since the configured default removes
the absence of a value.
Only has an effect when columnar index mode is active.
        - `boost` (number)
        - `eager_global_ordinals` (boolean)
        - `index` (boolean)
        - `index_options` (enum)
          Values: `docs`, `freqs`, `positions`, `offsets`
        - `script` (string)
        - `on_script_error` (enum)
          Values: `fail`, `continue`
        - `normalizer` (string)
        - `norms` (boolean)
        - `null_value` (string)
        - `similarity` (union string) — nullable
          One of: `string`
        - `split_queries_on_whitespace` (boolean)
        - `time_series_dimension` (boolean)
          For internal use by Elastic only. Marks the field as a time series dimension. Defaults to false.
      - **type: match_only_text** (`type: match_only_text`)
        A variant of text that trades scoring and efficiency of positional queries for space efficiency. This field
effectively stores data the same way as a text field that only indexes documents (index_options: docs) and
disables norms (norms: false). Term queries perform as fast if not faster as on text fields, however queries
that need positions such as the match_phrase query perform slower as they need to look at the _source document
to verify whether a phrase matches. All queries return constant scores that are equal to 1.0.
        - `type` (enum)
          Values: `match_only_text`
        - `fields` (map string to oneOf) — recursive
          Multi-fields allow the same string value to be indexed in multiple ways for different purposes, such as one
field for search and a multi-field for sorting and aggregations, or the same string value analyzed by different analyzers.
        - `meta` (map string to string)
          Metadata about the field.
        - `copy_to` (union oneOf)
          Allows you to copy the values of multiple fields into a group
field, which can then be queried as a single field.
          One of: `string[]` or `string`
      - **type: percolator** (`type: percolator`)
        - `type` (enum)
          Values: `percolator`
        - `meta` (map string to string)
          Metadata about the field.
        - `properties` (map string to oneOf) — recursive
        - `ignore_above` (number)
        - `dynamic` (enum)
          Values: `strict`, `runtime`, `true`, `false`
        - `fields` (map string to oneOf) — recursive
        - `synthetic_source_keep` (enum)
          

Supported values include:
  - `none`: Synthetic source diverges from the original source (default)
  - `arrays`: Arrays of the corresponding field or object preserve the original element ordering and duplicate elements.
The synthetic source fragment for such arrays is not guaranteed to match the original source exactly,
e.g. array [1, 2, [5], [[4, [3]]], 5] may appear as-is or in an equivalent format like [1, 2, 5, 4, 3, 5].
The exact format may change in the future, in an effort to reduce the storage overhead of this option.
  - `all`: The source for both singleton instances and arrays of the corresponding field or object gets recorded.
When applied to objects, the source of all sub-objects and sub-fields gets captured.
Furthermore, the original source of arrays gets captured and appears in synthetic source with no modifications.
          Values: `none`, `arrays`, `all`
      - **type: rank_feature** (`type: rank_feature`)
        - `type` (enum)
          Values: `rank_feature`
        - `meta` (map string to string)
          Metadata about the field.
        - `properties` (map string to oneOf) — recursive
        - `ignore_above` (number)
        - `dynamic` (enum)
          Values: `strict`, `runtime`, `true`, `false`
        - `fields` (map string to oneOf) — recursive
        - `synthetic_source_keep` (enum)
          

Supported values include:
  - `none`: Synthetic source diverges from the original source (default)
  - `arrays`: Arrays of the corresponding field or object preserve the original element ordering and duplicate elements.
The synthetic source fragment for such arrays is not guaranteed to match the original source exactly,
e.g. array [1, 2, [5], [[4, [3]]], 5] may appear as-is or in an equivalent format like [1, 2, 5, 4, 3, 5].
The exact format may change in the future, in an effort to reduce the storage overhead of this option.
  - `all`: The source for both singleton instances and arrays of the corresponding field or object gets recorded.
When applied to objects, the source of all sub-objects and sub-fields gets captured.
Furthermore, the original source of arrays gets captured and appears in synthetic source with no modifications.
          Values: `none`, `arrays`, `all`
        - `positive_score_impact` (boolean)
      - **type: rank_features** (`type: rank_features`)
        - `type` (enum)
          Values: `rank_features`
        - `meta` (map string to string)
          Metadata about the field.
        - `properties` (map string to oneOf) — recursive
        - `ignore_above` (number)
        - `dynamic` (enum)
          Values: `strict`, `runtime`, `true`, `false`
        - `fields` (map string to oneOf) — recursive
        - `synthetic_source_keep` (enum)
          

Supported values include:
  - `none`: Synthetic source diverges from the original source (default)
  - `arrays`: Arrays of the corresponding field or object preserve the original element ordering and duplicate elements.
The synthetic source fragment for such arrays is not guaranteed to match the original source exactly,
e.g. array [1, 2, [5], [[4, [3]]], 5] may appear as-is or in an equivalent format like [1, 2, 5, 4, 3, 5].
The exact format may change in the future, in an effort to reduce the storage overhead of this option.
  - `all`: The source for both singleton instances and arrays of the corresponding field or object gets recorded.
When applied to objects, the source of all sub-objects and sub-fields gets captured.
Furthermore, the original source of arrays gets captured and appears in synthetic source with no modifications.
          Values: `none`, `arrays`, `all`
        - `positive_score_impact` (boolean)
      - **type: search_as_you_type** (`type: search_as_you_type`)
        - `type` (enum)
          Values: `search_as_you_type`
        - `meta` (map string to string)
          Metadata about the field.
        - `properties` (map string to oneOf) — recursive
        - `ignore_above` (number)
        - `dynamic` (enum)
          Values: `strict`, `runtime`, `true`, `false`
        - `fields` (map string to oneOf) — recursive
        - `synthetic_source_keep` (enum)
          

Supported values include:
  - `none`: Synthetic source diverges from the original source (default)
  - `arrays`: Arrays of the corresponding field or object preserve the original element ordering and duplicate elements.
The synthetic source fragment for such arrays is not guaranteed to match the original source exactly,
e.g. array [1, 2, [5], [[4, [3]]], 5] may appear as-is or in an equivalent format like [1, 2, 5, 4, 3, 5].
The exact format may change in the future, in an effort to reduce the storage overhead of this option.
  - `all`: The source for both singleton instances and arrays of the corresponding field or object gets recorded.
When applied to objects, the source of all sub-objects and sub-fields gets captured.
Furthermore, the original source of arrays gets captured and appears in synthetic source with no modifications.
          Values: `none`, `arrays`, `all`
        - `copy_to` (union oneOf)
          One of: `string[]` or `string`
        - `store` (boolean)
        - `analyzer` (string)
        - `index` (boolean)
        - `index_options` (enum)
          Values: `docs`, `freqs`, `positions`, `offsets`
        - `max_shingle_size` (number)
        - `norms` (boolean)
        - `search_analyzer` (string)
        - `search_quote_analyzer` (string)
        - `similarity` (union string) — nullable
          One of: `string`
        - `term_vector` (enum)
          Values: `no`, `yes`, `with_offsets`, `with_positions`, `with_positions_offsets`, `with_positions_offsets_payloads`, `with_positions_payloads`
      - **type: text** (`type: text`)
        - `type` (enum)
          Values: `text`
        - `meta` (map string to string)
          Metadata about the field.
        - `properties` (map string to oneOf) — recursive
        - `ignore_above` (number)
        - `dynamic` (enum)
          Values: `strict`, `runtime`, `true`, `false`
        - `fields` (map string to oneOf) — recursive
        - `synthetic_source_keep` (enum)
          

Supported values include:
  - `none`: Synthetic source diverges from the original source (default)
  - `arrays`: Arrays of the corresponding field or object preserve the original element ordering and duplicate elements.
The synthetic source fragment for such arrays is not guaranteed to match the original source exactly,
e.g. array [1, 2, [5], [[4, [3]]], 5] may appear as-is or in an equivalent format like [1, 2, 5, 4, 3, 5].
The exact format may change in the future, in an effort to reduce the storage overhead of this option.
  - `all`: The source for both singleton instances and arrays of the corresponding field or object gets recorded.
When applied to objects, the source of all sub-objects and sub-fields gets captured.
Furthermore, the original source of arrays gets captured and appears in synthetic source with no modifications.
          Values: `none`, `arrays`, `all`
        - `copy_to` (union oneOf)
          One of: `string[]` or `string`
        - `store` (boolean)
        - `analyzer` (string)
        - `boost` (number)
        - `eager_global_ordinals` (boolean)
        - `fielddata` (boolean)
        - `fielddata_frequency_filter` (object)
          - `max` (number)
          - `min` (number)
          - `min_segment_size` (number)
        - `index` (boolean)
        - `index_options` (enum)
          Values: `docs`, `freqs`, `positions`, `offsets`
        - `index_phrases` (boolean)
        - `index_prefixes` (union oneOf) — nullable
          - **TextIndexPrefixes**
            - `max_chars` (number)
            - `min_chars` (number)
          - **string**
        - `norms` (boolean)
        - `position_increment_gap` (number)
        - `search_analyzer` (string)
        - `search_quote_analyzer` (string)
        - `similarity` (union string) — nullable
          One of: `string`
        - `term_vector` (enum)
          Values: `no`, `yes`, `with_offsets`, `with_positions`, `with_positions_offsets`, `with_positions_offsets_payloads`, `with_positions_payloads`
      - **type: version** (`type: version`)
        - `type` (enum)
          Values: `version`
        - `meta` (map string to string)
          Metadata about the field.
        - `properties` (map string to oneOf) — recursive
        - `ignore_above` (number)
        - `dynamic` (enum)
          Values: `strict`, `runtime`, `true`, `false`
        - `fields` (map string to oneOf) — recursive
        - `synthetic_source_keep` (enum)
          

Supported values include:
  - `none`: Synthetic source diverges from the original source (default)
  - `arrays`: Arrays of the corresponding field or object preserve the original element ordering and duplicate elements.
The synthetic source fragment for such arrays is not guaranteed to match the original source exactly,
e.g. array [1, 2, [5], [[4, [3]]], 5] may appear as-is or in an equivalent format like [1, 2, 5, 4, 3, 5].
The exact format may change in the future, in an effort to reduce the storage overhead of this option.
  - `all`: The source for both singleton instances and arrays of the corresponding field or object gets recorded.
When applied to objects, the source of all sub-objects and sub-fields gets captured.
Furthermore, the original source of arrays gets captured and appears in synthetic source with no modifications.
          Values: `none`, `arrays`, `all`
        - `copy_to` (union oneOf)
          One of: `string[]` or `string`
        - `store` (boolean)
        - `doc_values` (union oneOf)
          - **boolean**
          - **DocValuesConfig**
            Configuration object for doc values when sub-parameters are needed.
            - `multi_value` (boolean · default: true)
              If `false`, the field is treated as single-valued, enabling optimized storage.
Only has an effect when columnar index mode is active.
            - `nullability` (boolean · default: true)
              If `false`, every document must provide a non-null value for the field: a document that
omits the field, sets it to `null`, or supplies only null values (an empty array or an
all-null array) is rejected at index time.
A field that defines `null_value` is always exempt, since the configured default removes
the absence of a value.
Only has an effect when columnar index mode is active.
      - **type: wildcard** (`type: wildcard`)
        - `type` (enum)
          Values: `wildcard`
        - `meta` (map string to string)
          Metadata about the field.
        - `properties` (map string to oneOf) — recursive
        - `ignore_above` (number)
        - `dynamic` (enum)
          Values: `strict`, `runtime`, `true`, `false`
        - `fields` (map string to oneOf) — recursive
        - `synthetic_source_keep` (enum)
          

Supported values include:
  - `none`: Synthetic source diverges from the original source (default)
  - `arrays`: Arrays of the corresponding field or object preserve the original element ordering and duplicate elements.
The synthetic source fragment for such arrays is not guaranteed to match the original source exactly,
e.g. array [1, 2, [5], [[4, [3]]], 5] may appear as-is or in an equivalent format like [1, 2, 5, 4, 3, 5].
The exact format may change in the future, in an effort to reduce the storage overhead of this option.
  - `all`: The source for both singleton instances and arrays of the corresponding field or object gets recorded.
When applied to objects, the source of all sub-objects and sub-fields gets captured.
Furthermore, the original source of arrays gets captured and appears in synthetic source with no modifications.
          Values: `none`, `arrays`, `all`
        - `copy_to` (union oneOf)
          One of: `string[]` or `string`
        - `store` (boolean)
        - `doc_values` (union oneOf)
          - **boolean**
          - **DocValuesConfig**
            Configuration object for doc values when sub-parameters are needed.
            - `multi_value` (boolean · default: true)
              If `false`, the field is treated as single-valued, enabling optimized storage.
Only has an effect when columnar index mode is active.
            - `nullability` (boolean · default: true)
              If `false`, every document must provide a non-null value for the field: a document that
omits the field, sets it to `null`, or supplies only null values (an empty array or an
all-null array) is rejected at index time.
A field that defines `null_value` is always exempt, since the configured default removes
the absence of a value.
Only has an effect when columnar index mode is active.
        - `null_value` (string)
      - **type: date_nanos** (`type: date_nanos`)
        - `type` (enum)
          Values: `date_nanos`
        - `meta` (map string to string)
          Metadata about the field.
        - `properties` (map string to oneOf) — recursive
        - `ignore_above` (number)
        - `dynamic` (enum)
          Values: `strict`, `runtime`, `true`, `false`
        - `fields` (map string to oneOf) — recursive
        - `synthetic_source_keep` (enum)
          

Supported values include:
  - `none`: Synthetic source diverges from the original source (default)
  - `arrays`: Arrays of the corresponding field or object preserve the original element ordering and duplicate elements.
The synthetic source fragment for such arrays is not guaranteed to match the original source exactly,
e.g. array [1, 2, [5], [[4, [3]]], 5] may appear as-is or in an equivalent format like [1, 2, 5, 4, 3, 5].
The exact format may change in the future, in an effort to reduce the storage overhead of this option.
  - `all`: The source for both singleton instances and arrays of the corresponding field or object gets recorded.
When applied to objects, the source of all sub-objects and sub-fields gets captured.
Furthermore, the original source of arrays gets captured and appears in synthetic source with no modifications.
          Values: `none`, `arrays`, `all`
        - `copy_to` (union oneOf)
          One of: `string[]` or `string`
        - `store` (boolean)
        - `doc_values` (union oneOf)
          - **boolean**
          - **DocValuesConfig**
            Configuration object for doc values when sub-parameters are needed.
            - `multi_value` (boolean · default: true)
              If `false`, the field is treated as single-valued, enabling optimized storage.
Only has an effect when columnar index mode is active.
            - `nullability` (boolean · default: true)
              If `false`, every document must provide a non-null value for the field: a document that
omits the field, sets it to `null`, or supplies only null values (an empty array or an
all-null array) is rejected at index time.
A field that defines `null_value` is always exempt, since the configured default removes
the absence of a value.
Only has an effect when columnar index mode is active.
        - `boost` (number)
        - `format` (string)
        - `ignore_malformed` (boolean)
        - `index` (boolean)
        - `script` (string)
        - `on_script_error` (enum)
          Values: `fail`, `continue`
        - `null_value` (union oneOf)
          One of: `string` or `number`
        - `precision_step` (number)
      - **type: date** (`type: date`)
        - `type` (enum)
          Values: `date`
        - `meta` (map string to string)
          Metadata about the field.
        - `properties` (map string to oneOf) — recursive
        - `ignore_above` (number)
        - `dynamic` (enum)
          Values: `strict`, `runtime`, `true`, `false`
        - `fields` (map string to oneOf) — recursive
        - `synthetic_source_keep` (enum)
          

Supported values include:
  - `none`: Synthetic source diverges from the original source (default)
  - `arrays`: Arrays of the corresponding field or object preserve the original element ordering and duplicate elements.
The synthetic source fragment for such arrays is not guaranteed to match the original source exactly,
e.g. array [1, 2, [5], [[4, [3]]], 5] may appear as-is or in an equivalent format like [1, 2, 5, 4, 3, 5].
The exact format may change in the future, in an effort to reduce the storage overhead of this option.
  - `all`: The source for both singleton instances and arrays of the corresponding field or object gets recorded.
When applied to objects, the source of all sub-objects and sub-fields gets captured.
Furthermore, the original source of arrays gets captured and appears in synthetic source with no modifications.
          Values: `none`, `arrays`, `all`
        - `copy_to` (union oneOf)
          One of: `string[]` or `string`
        - `store` (boolean)
        - `doc_values` (union oneOf)
          - **boolean**
          - **DocValuesConfig**
            Configuration object for doc values when sub-parameters are needed.
            - `multi_value` (boolean · default: true)
              If `false`, the field is treated as single-valued, enabling optimized storage.
Only has an effect when columnar index mode is active.
            - `nullability` (boolean · default: true)
              If `false`, every document must provide a non-null value for the field: a document that
omits the field, sets it to `null`, or supplies only null values (an empty array or an
all-null array) is rejected at index time.
A field that defines `null_value` is always exempt, since the configured default removes
the absence of a value.
Only has an effect when columnar index mode is active.
        - `boost` (number)
        - `fielddata` (object)
          - `format` (enum)
            Values: `array`, `disabled`
        - `format` (string)
        - `ignore_malformed` (boolean)
        - `index` (boolean)
        - `script` (string)
        - `on_script_error` (enum)
          Values: `fail`, `continue`
        - `null_value` (union oneOf)
          One of: `string` or `number`
        - `precision_step` (number)
        - `locale` (string)
      - **type: aggregate_metric_double** (`type: aggregate_metric_double`)
        - `type` (enum)
          Values: `aggregate_metric_double`
        - `meta` (map string to string)
          Metadata about the field.
        - `properties` (map string to oneOf) — recursive
        - `ignore_above` (number)
        - `dynamic` (enum)
          Values: `strict`, `runtime`, `true`, `false`
        - `fields` (map string to oneOf) — recursive
        - `synthetic_source_keep` (enum)
          

Supported values include:
  - `none`: Synthetic source diverges from the original source (default)
  - `arrays`: Arrays of the corresponding field or object preserve the original element ordering and duplicate elements.
The synthetic source fragment for such arrays is not guaranteed to match the original source exactly,
e.g. array [1, 2, [5], [[4, [3]]], 5] may appear as-is or in an equivalent format like [1, 2, 5, 4, 3, 5].
The exact format may change in the future, in an effort to reduce the storage overhead of this option.
  - `all`: The source for both singleton instances and arrays of the corresponding field or object gets recorded.
When applied to objects, the source of all sub-objects and sub-fields gets captured.
Furthermore, the original source of arrays gets captured and appears in synthetic source with no modifications.
          Values: `none`, `arrays`, `all`
        - `default_metric` (string)
        - `ignore_malformed` (boolean)
        - `metrics` (string[])
        - `time_series_metric` (enum)
          Values: `gauge`, `counter`, `summary`, `histogram`, `position`
      - **type: dense_vector** (`type: dense_vector`)
        - `type` (enum)
          Values: `dense_vector`
        - `meta` (map string to string)
          Metadata about the field.
        - `properties` (map string to oneOf) — recursive
        - `ignore_above` (number)
        - `dynamic` (enum)
          Values: `strict`, `runtime`, `true`, `false`
        - `fields` (map string to oneOf) — recursive
        - `synthetic_source_keep` (enum)
          

Supported values include:
  - `none`: Synthetic source diverges from the original source (default)
  - `arrays`: Arrays of the corresponding field or object preserve the original element ordering and duplicate elements.
The synthetic source fragment for such arrays is not guaranteed to match the original source exactly,
e.g. array [1, 2, [5], [[4, [3]]], 5] may appear as-is or in an equivalent format like [1, 2, 5, 4, 3, 5].
The exact format may change in the future, in an effort to reduce the storage overhead of this option.
  - `all`: The source for both singleton instances and arrays of the corresponding field or object gets recorded.
When applied to objects, the source of all sub-objects and sub-fields gets captured.
Furthermore, the original source of arrays gets captured and appears in synthetic source with no modifications.
          Values: `none`, `arrays`, `all`
        - `dims` (number)
          Number of vector dimensions. Can't exceed `4096`. If `dims` is not specified, it will be set to the length of
the first vector added to the field.
        - `element_type` (enum · default: float)
          The data type used to encode vectors. The supported data types are `float` (default), `byte`, and `bit`.

Supported values include:
  - `bit`: Indexes a single bit per dimension. Useful for very high-dimensional vectors or models that specifically support
bit vectors.

NOTE: when using `bit`, the number of dimensions must be a multiple of `8` and must represent the number of bits.
  - `byte`: Indexes a 1-byte integer value per dimension.
  - `float`: Indexes a 4-byte floating-point value per dimension.
          Values: `bit`, `byte`, `float`
        - `index` (boolean · default: true)
          If `true`, you can search this field using the kNN search API.
        - `index_options` (object)
          An optional section that configures the kNN indexing algorithm. The HNSW algorithm has two internal parameters
that influence how the data structure is built. These can be adjusted to improve the accuracy of results, at the
expense of slower indexing speed.

This parameter can only be specified when `index` is `true`.
          - `confidence_interval` (number) — deprecated
            The confidence interval to use when quantizing the vectors. Can be any value between and including `0.90` and
`1.0` or exactly `0`. When the value is `0`, this indicates that dynamic quantiles should be calculated for
optimized quantization. When between `0.90` and `1.0`, this value restricts the values used when calculating
the quantization thresholds.

For example, a value of `0.95` will only use the middle `95%` of the values when calculating the quantization
thresholds (e.g. the highest and lowest `2.5%` of values will be ignored).

Defaults to `1/(dims + 1)` for `int8` quantized vectors and `0` for `int4` for dynamic quantile calculation.

Only applicable to `int8_hnsw`, `int4_hnsw`, `int8_flat`, and `int4_flat` index types.
          - `ef_construction` (number · default: 100)
            The number of candidates to track while assembling the list of nearest neighbors for each new node.

Only applicable to `hnsw`, `int8_hnsw`, `bbq_hnsw`, and `int4_hnsw` index types.
          - `m` (number · default: 16)
            The number of neighbors each node will be connected to in the HNSW graph.

Only applicable to `hnsw`, `int8_hnsw`, `bbq_hnsw`, and `int4_hnsw` index types.
          - `type` (enum)
            The type of kNN algorithm to use.

Supported values include:
  - `bbq_flat`: This utilizes a brute-force search algorithm in addition to automatically quantizing to binary vectors.
Only supports `element_type` of `float`.
  - `bbq_hnsw`: This utilizes the HNSW algorithm in addition to automatic binary quantization for scalable approximate kNN
search with `element_type` of `float`.

This can reduce the memory footprint by nearly 32x at the cost of some accuracy.
  - `flat`: This utilizes a brute-force search algorithm for exact kNN search. This supports all `element_type` values.
  - `hnsw`: This utilizes the HNSW algorithm for scalable approximate kNN search. This supports all `element_type` values.
  - `int4_flat`: This utilizes a brute-force search algorithm in addition to automatically half-byte scalar quantization.
Only supports `element_type` of `float`.
  - `int4_hnsw`: This utilizes the HNSW algorithm in addition to automatically scalar quantization for scalable approximate kNN
search with `element_type` of `float`.

This can reduce the memory footprint by 8x at the cost of some accuracy.
  - `int8_flat`: This utilizes a brute-force search algorithm in addition to automatically scalar quantization. Only supports
`element_type` of `float`.
  - `int8_hnsw`: The default index type for `float` vectors. This utilizes the HNSW algorithm in addition to automatically scalar
quantization for scalable approximate kNN search with `element_type` of `float`.

This can reduce the memory footprint by 4x at the cost of some accuracy.
            Values: `bbq_flat`, `bbq_hnsw`, `flat`, `hnsw`, `int4_flat`, `int4_hnsw`, `int8_flat`, `int8_hnsw`
          - `rescore_vector` (object)
            The rescore vector options. This is only applicable to `bbq_disk`, `bbq_hnsw`, `int4_hnsw`, `int8_hnsw`, `bbq_flat`, `int4_flat`, and `int8_flat` index types.
            - `oversample` (number)
              The oversampling factor to use when searching for the nearest neighbor. This is only applicable to the quantized formats: `bbq_*`, `int4_*`, and `int8_*`.
When provided, `oversample * k` vectors will be gathered and then their scores will be re-computed with the original vectors.

valid values are between `1.0` and `10.0` (inclusive), or `0` exactly to disable oversampling.
        - `similarity` (enum)
          The vector similarity metric to use in kNN search.

Documents are ranked by their vector field's similarity to the query vector. The `_score` of each document will
be derived from the similarity, in a way that ensures scores are positive and that a larger score corresponds
to a higher ranking.

Defaults to `l2_norm` when `element_type` is `bit` otherwise defaults to `cosine`.

`bit` vectors only support `l2_norm` as their similarity metric.

This parameter can only be specified when `index` is `true`.

Supported values include:
  - `cosine`: Computes the cosine similarity. During indexing Elasticsearch automatically normalizes vectors with `cosine`
similarity to unit length. This allows to internally use `dot_product` for computing similarity, which is more
efficient. Original un-normalized vectors can be still accessed through scripts.

The document `_score` is computed as `(1 + cosine(query, vector)) / 2`.

The `cosine` similarity does not allow vectors with zero magnitude, since cosine is not defined in this case.
  - `dot_product`: Computes the dot product of two unit vectors. This option provides an optimized way to perform cosine similarity.
The constraints and computed score are defined by `element_type`.

When `element_type` is `float`, all vectors must be unit length, including both document and query vectors.

The document `_score` is computed as `(1 + dot_product(query, vector)) / 2`.

When `element_type` is `byte`, all vectors must have the same length including both document and query vectors or
results will be inaccurate.

The document `_score` is computed as `0.5 + (dot_product(query, vector) / (32768 * dims))` where `dims` is the
number of dimensions per vector.
  - `l2_norm`: Computes similarity based on the `L2` distance (also known as Euclidean distance) between the vectors.

The document `_score` is computed as `1 / (1 + l2_norm(query, vector)^2)`.

For `bit` vectors, instead of using `l2_norm`, the `hamming` distance between the vectors is used.

The `_score` transformation is `(numBits - hamming(a, b)) / numBits`.
  - `max_inner_product`: Computes the maximum inner product of two vectors. This is similar to `dot_product`, but doesn't require vectors
to be normalized. This means that each vector’s magnitude can significantly effect the score.

The document `_score` is adjusted to prevent negative values. For `max_inner_product` values `< 0`, the `_score`
is `1 / (1 + -1 * max_inner_product(query, vector))`. For non-negative `max_inner_product` results the `_score`
is calculated `max_inner_product(query, vector) + 1`.
          Values: `cosine`, `dot_product`, `l2_norm`, `max_inner_product`
      - **type: flattened** (`type: flattened`)
        - `type` (enum)
          Values: `flattened`
        - `meta` (map string to string)
          Metadata about the field.
        - `properties` (map string to oneOf) — recursive
        - `ignore_above` (number)
        - `dynamic` (enum)
          Values: `strict`, `runtime`, `true`, `false`
        - `fields` (map string to oneOf) — recursive
        - `synthetic_source_keep` (enum)
          

Supported values include:
  - `none`: Synthetic source diverges from the original source (default)
  - `arrays`: Arrays of the corresponding field or object preserve the original element ordering and duplicate elements.
The synthetic source fragment for such arrays is not guaranteed to match the original source exactly,
e.g. array [1, 2, [5], [[4, [3]]], 5] may appear as-is or in an equivalent format like [1, 2, 5, 4, 3, 5].
The exact format may change in the future, in an effort to reduce the storage overhead of this option.
  - `all`: The source for both singleton instances and arrays of the corresponding field or object gets recorded.
When applied to objects, the source of all sub-objects and sub-fields gets captured.
Furthermore, the original source of arrays gets captured and appears in synthetic source with no modifications.
          Values: `none`, `arrays`, `all`
        - `boost` (number)
        - `depth_limit` (number)
        - `doc_values` (boolean)
        - `eager_global_ordinals` (boolean)
        - `index` (boolean)
        - `index_options` (enum)
          Values: `docs`, `freqs`, `positions`, `offsets`
        - `null_value` (string)
        - `preserve_leaf_arrays` (enum)
          How leaf arrays are represented in synthetic source.
When set to `lossy`, leaf arrays are sorted, de-nulled, and deduplicated in the returned synthetic source.
When set to `exact`, leaf arrays preserve order, nulls, and duplicates.
          Values: `lossy`, `exact`
        - `similarity` (string)
        - `split_queries_on_whitespace` (boolean)
        - `time_series_dimensions` (string[])
      - **type: nested** (`type: nested`)
        - `type` (enum)
          Values: `nested`
        - `meta` (map string to string)
          Metadata about the field.
        - `properties` (map string to oneOf) — recursive
        - `ignore_above` (number)
        - `dynamic` (enum)
          Values: `strict`, `runtime`, `true`, `false`
        - `fields` (map string to oneOf) — recursive
        - `synthetic_source_keep` (enum)
          

Supported values include:
  - `none`: Synthetic source diverges from the original source (default)
  - `arrays`: Arrays of the corresponding field or object preserve the original element ordering and duplicate elements.
The synthetic source fragment for such arrays is not guaranteed to match the original source exactly,
e.g. array [1, 2, [5], [[4, [3]]], 5] may appear as-is or in an equivalent format like [1, 2, 5, 4, 3, 5].
The exact format may change in the future, in an effort to reduce the storage overhead of this option.
  - `all`: The source for both singleton instances and arrays of the corresponding field or object gets recorded.
When applied to objects, the source of all sub-objects and sub-fields gets captured.
Furthermore, the original source of arrays gets captured and appears in synthetic source with no modifications.
          Values: `none`, `arrays`, `all`
        - `copy_to` (union oneOf)
          One of: `string[]` or `string`
        - `store` (boolean)
        - `enabled` (boolean)
        - `include_in_parent` (boolean)
        - `include_in_root` (boolean)
      - **type: object** (`type: object`)
        - `type` (enum)
          Values: `object`
        - `meta` (map string to string)
          Metadata about the field.
        - `properties` (map string to oneOf) — recursive
        - `ignore_above` (number)
        - `dynamic` (enum)
          Values: `strict`, `runtime`, `true`, `false`
        - `fields` (map string to oneOf) — recursive
        - `synthetic_source_keep` (enum)
          

Supported values include:
  - `none`: Synthetic source diverges from the original source (default)
  - `arrays`: Arrays of the corresponding field or object preserve the original element ordering and duplicate elements.
The synthetic source fragment for such arrays is not guaranteed to match the original source exactly,
e.g. array [1, 2, [5], [[4, [3]]], 5] may appear as-is or in an equivalent format like [1, 2, 5, 4, 3, 5].
The exact format may change in the future, in an effort to reduce the storage overhead of this option.
  - `all`: The source for both singleton instances and arrays of the corresponding field or object gets recorded.
When applied to objects, the source of all sub-objects and sub-fields gets captured.
Furthermore, the original source of arrays gets captured and appears in synthetic source with no modifications.
          Values: `none`, `arrays`, `all`
        - `copy_to` (union oneOf)
          One of: `string[]` or `string`
        - `store` (boolean)
        - `enabled` (boolean)
        - `subobjects` (enum)
          Values: `true`, `false`
      - **type: passthrough** (`type: passthrough`)
        - `type` (enum)
          Values: `passthrough`
        - `meta` (map string to string)
          Metadata about the field.
        - `properties` (map string to oneOf) — recursive
        - `ignore_above` (number)
        - `dynamic` (enum)
          Values: `strict`, `runtime`, `true`, `false`
        - `fields` (map string to oneOf) — recursive
        - `synthetic_source_keep` (enum)
          

Supported values include:
  - `none`: Synthetic source diverges from the original source (default)
  - `arrays`: Arrays of the corresponding field or object preserve the original element ordering and duplicate elements.
The synthetic source fragment for such arrays is not guaranteed to match the original source exactly,
e.g. array [1, 2, [5], [[4, [3]]], 5] may appear as-is or in an equivalent format like [1, 2, 5, 4, 3, 5].
The exact format may change in the future, in an effort to reduce the storage overhead of this option.
  - `all`: The source for both singleton instances and arrays of the corresponding field or object gets recorded.
When applied to objects, the source of all sub-objects and sub-fields gets captured.
Furthermore, the original source of arrays gets captured and appears in synthetic source with no modifications.
          Values: `none`, `arrays`, `all`
        - `copy_to` (union oneOf)
          One of: `string[]` or `string`
        - `store` (boolean)
        - `enabled` (boolean)
        - `priority` (number)
        - `time_series_dimension` (boolean)
      - **type: rank_vectors** (`type: rank_vectors`)
        Technical preview
        - `type` (enum)
          Values: `rank_vectors`
        - `meta` (map string to string)
          Metadata about the field.
        - `properties` (map string to oneOf) — recursive
        - `ignore_above` (number)
        - `dynamic` (enum)
          Values: `strict`, `runtime`, `true`, `false`
        - `fields` (map string to oneOf) — recursive
        - `synthetic_source_keep` (enum)
          

Supported values include:
  - `none`: Synthetic source diverges from the original source (default)
  - `arrays`: Arrays of the corresponding field or object preserve the original element ordering and duplicate elements.
The synthetic source fragment for such arrays is not guaranteed to match the original source exactly,
e.g. array [1, 2, [5], [[4, [3]]], 5] may appear as-is or in an equivalent format like [1, 2, 5, 4, 3, 5].
The exact format may change in the future, in an effort to reduce the storage overhead of this option.
  - `all`: The source for both singleton instances and arrays of the corresponding field or object gets recorded.
When applied to objects, the source of all sub-objects and sub-fields gets captured.
Furthermore, the original source of arrays gets captured and appears in synthetic source with no modifications.
          Values: `none`, `arrays`, `all`
        - `element_type` (enum)
          Values: `byte`, `float`, `bit`
        - `dims` (number)
      - **type: semantic_text** (`type: semantic_text`)
        - `type` (enum)
          Values: `semantic_text`
        - `meta` (map string to string)
        - `inference_id` (string · default: .jina-embeddings-v5-text-small)
          Inference endpoint that will be used to generate embeddings for the field.
This parameter cannot be updated. Use the Create inference API to create the endpoint.
If `search_inference_id` is specified, the inference endpoint will only be used at index time.
If the `inference_id` is not specified, it will default to `.jina-embeddings-v5-text-small` if the cluster is authorized to use the Elastic Inference Service,
otherwise it will default to `.elser-2-elasticsearch`. The `.elser-2-elasticsearch` inference endpoint relies on a local ML node to run the ELSER model.
        - `search_inference_id` (string)
          Inference endpoint that will be used to generate embeddings at query time.
You can update this parameter by using the Update mapping API. Use the Create inference API to create the endpoint.
If not specified, the inference endpoint defined by inference_id will be used at both index and query time.
        - `index_options` (object)
          Settings for index_options that override any defaults used by semantic_text, for example
specific quantization settings.
          - `dense_vector` (object)
            - `confidence_interval` (number) — deprecated
              The confidence interval to use when quantizing the vectors. Can be any value between and including `0.90` and
`1.0` or exactly `0`. When the value is `0`, this indicates that dynamic quantiles should be calculated for
optimized quantization. When between `0.90` and `1.0`, this value restricts the values used when calculating
the quantization thresholds.

For example, a value of `0.95` will only use the middle `95%` of the values when calculating the quantization
thresholds (e.g. the highest and lowest `2.5%` of values will be ignored).

Defaults to `1/(dims + 1)` for `int8` quantized vectors and `0` for `int4` for dynamic quantile calculation.

Only applicable to `int8_hnsw`, `int4_hnsw`, `int8_flat`, and `int4_flat` index types.
            - `ef_construction` (number · default: 100)
              The number of candidates to track while assembling the list of nearest neighbors for each new node.

Only applicable to `hnsw`, `int8_hnsw`, `bbq_hnsw`, and `int4_hnsw` index types.
            - `m` (number · default: 16)
              The number of neighbors each node will be connected to in the HNSW graph.

Only applicable to `hnsw`, `int8_hnsw`, `bbq_hnsw`, and `int4_hnsw` index types.
            - `type` (enum)
              The type of kNN algorithm to use.

Supported values include:
  - `bbq_flat`: This utilizes a brute-force search algorithm in addition to automatically quantizing to binary vectors.
Only supports `element_type` of `float`.
  - `bbq_hnsw`: This utilizes the HNSW algorithm in addition to automatic binary quantization for scalable approximate kNN
search with `element_type` of `float`.

This can reduce the memory footprint by nearly 32x at the cost of some accuracy.
  - `flat`: This utilizes a brute-force search algorithm for exact kNN search. This supports all `element_type` values.
  - `hnsw`: This utilizes the HNSW algorithm for scalable approximate kNN search. This supports all `element_type` values.
  - `int4_flat`: This utilizes a brute-force search algorithm in addition to automatically half-byte scalar quantization.
Only supports `element_type` of `float`.
  - `int4_hnsw`: This utilizes the HNSW algorithm in addition to automatically scalar quantization for scalable approximate kNN
search with `element_type` of `float`.

This can reduce the memory footprint by 8x at the cost of some accuracy.
  - `int8_flat`: This utilizes a brute-force search algorithm in addition to automatically scalar quantization. Only supports
`element_type` of `float`.
  - `int8_hnsw`: The default index type for `float` vectors. This utilizes the HNSW algorithm in addition to automatically scalar
quantization for scalable approximate kNN search with `element_type` of `float`.

This can reduce the memory footprint by 4x at the cost of some accuracy.
              Values: `bbq_flat`, `bbq_hnsw`, `flat`, `hnsw`, `int4_flat`, `int4_hnsw`, `int8_flat`, `int8_hnsw`
            - `rescore_vector` (object)
              The rescore vector options. This is only applicable to `bbq_disk`, `bbq_hnsw`, `int4_hnsw`, `int8_hnsw`, `bbq_flat`, `int4_flat`, and `int8_flat` index types.
              - `oversample` (number)
                The oversampling factor to use when searching for the nearest neighbor. This is only applicable to the quantized formats: `bbq_*`, `int4_*`, and `int8_*`.
When provided, `oversample * k` vectors will be gathered and then their scores will be re-computed with the original vectors.

valid values are between `1.0` and `10.0` (inclusive), or `0` exactly to disable oversampling.
          - `sparse_vector` (object)
            - `prune` (boolean)
              Whether to perform pruning, omitting the non-significant tokens from the query to improve query performance.
If prune is true but the pruning_config is not specified, pruning will occur but default values will be used.
Default: false
            - `pruning_config` (object)
              Optional pruning configuration.
If enabled, this will omit non-significant tokens from the query in order to improve query performance.
This is only used if prune is set to true.
If prune is set to true but pruning_config is not specified, default values will be used.
              - `tokens_freq_ratio_threshold` (number · default: 5)
                Tokens whose frequency is more than this threshold times the average frequency of all tokens in the specified field are considered outliers and pruned.
              - `tokens_weight_threshold` (number · default: 0.4)
                Tokens whose weight is less than this threshold are considered nonsignificant and pruned.
              - `only_score_pruned_tokens` (boolean · default: false)
                Whether to only score pruned tokens, vs only scoring kept tokens.
        - `chunking_settings` (union oneOf) — nullable
          Settings for chunking text into smaller passages. If specified, these will override the
chunking settings sent in the inference endpoint associated with inference_id. If chunking settings are updated,
they will not be applied to existing documents until they are reindexed.
          - **ChunkingSettings**
            - `strategy` (string · default: sentence)
              The chunking strategy: `sentence`, `word`, `none` or `recursive`.

 * If `strategy` is set to `recursive`, you must also specify:

- `max_chunk_size`
- either `separators` or`separator_group`

Learn more about different chunking strategies in the linked documentation.
            - `max_chunk_size` (number · default: 250)
              The maximum size of a chunk in words.
This value cannot be lower than `20` (for `sentence` strategy) or `10` (for `word` strategy).
This value should not exceed the window size for the associated model.
            - `overlap` (number · default: 100)
              The number of overlapping words for chunks.
It is applicable only to a `word` chunking strategy.
This value cannot be higher than half the `max_chunk_size` value.
            - `sentence_overlap` (number · default: 1)
              The number of overlapping sentences for chunks.
It is applicable only for a `sentence` chunking strategy.
It can be either `1` or `0`.
            - `separator_group` (string)
              Only applicable to the `recursive` strategy and required when using it.

Sets a predefined list of separators in the saved chunking settings based on the selected text type.
Values can be `markdown` or `plaintext`.

Using this parameter is an alternative to manually specifying a custom `separators` list.
            - `separators` (string[])
              Only applicable to the `recursive` strategy and required when using it.

A list of strings used as possible split points when chunking text.

Each string can be a plain string or a regular expression (regex) pattern.
The system tries each separator in order to split the text, starting from the first item in the list.

After splitting, it attempts to recombine smaller pieces into larger chunks that stay within
the `max_chunk_size` limit, to reduce the total number of chunks generated.
          - **string**
        - `fields` (map string to oneOf) — recursive
          Multi-fields allow the same string value to be indexed in multiple ways for different purposes, such as one
field for search and a multi-field for sorting and aggregations, or the same string value analyzed by different analyzers.
      - **type: sparse_vector** (`type: sparse_vector`)
        - `type` (enum)
          Values: `sparse_vector`
        - `meta` (map string to string)
          Metadata about the field.
        - `properties` (map string to oneOf) — recursive
        - `ignore_above` (number)
        - `dynamic` (enum)
          Values: `strict`, `runtime`, `true`, `false`
        - `fields` (map string to oneOf) — recursive
        - `synthetic_source_keep` (enum)
          

Supported values include:
  - `none`: Synthetic source diverges from the original source (default)
  - `arrays`: Arrays of the corresponding field or object preserve the original element ordering and duplicate elements.
The synthetic source fragment for such arrays is not guaranteed to match the original source exactly,
e.g. array [1, 2, [5], [[4, [3]]], 5] may appear as-is or in an equivalent format like [1, 2, 5, 4, 3, 5].
The exact format may change in the future, in an effort to reduce the storage overhead of this option.
  - `all`: The source for both singleton instances and arrays of the corresponding field or object gets recorded.
When applied to objects, the source of all sub-objects and sub-fields gets captured.
Furthermore, the original source of arrays gets captured and appears in synthetic source with no modifications.
          Values: `none`, `arrays`, `all`
        - `store` (boolean)
        - `index_options` (object)
          Additional index options for the sparse vector field that controls the
token pruning behavior of the sparse vector field.
          - `prune` (boolean)
            Whether to perform pruning, omitting the non-significant tokens from the query to improve query performance.
If prune is true but the pruning_config is not specified, pruning will occur but default values will be used.
Default: false
          - `pruning_config` (object)
            Optional pruning configuration.
If enabled, this will omit non-significant tokens from the query in order to improve query performance.
This is only used if prune is set to true.
If prune is set to true but pruning_config is not specified, default values will be used.
            - `tokens_freq_ratio_threshold` (number · default: 5)
              Tokens whose frequency is more than this threshold times the average frequency of all tokens in the specified field are considered outliers and pruned.
            - `tokens_weight_threshold` (number · default: 0.4)
              Tokens whose weight is less than this threshold are considered nonsignificant and pruned.
            - `only_score_pruned_tokens` (boolean · default: false)
              Whether to only score pruned tokens, vs only scoring kept tokens.
      - **type: completion** (`type: completion`)
        - `type` (enum)
          Values: `completion`
        - `meta` (map string to string)
          Metadata about the field.
        - `properties` (map string to oneOf) — recursive
        - `ignore_above` (number)
        - `dynamic` (enum)
          Values: `strict`, `runtime`, `true`, `false`
        - `fields` (map string to oneOf) — recursive
        - `synthetic_source_keep` (enum)
          

Supported values include:
  - `none`: Synthetic source diverges from the original source (default)
  - `arrays`: Arrays of the corresponding field or object preserve the original element ordering and duplicate elements.
The synthetic source fragment for such arrays is not guaranteed to match the original source exactly,
e.g. array [1, 2, [5], [[4, [3]]], 5] may appear as-is or in an equivalent format like [1, 2, 5, 4, 3, 5].
The exact format may change in the future, in an effort to reduce the storage overhead of this option.
  - `all`: The source for both singleton instances and arrays of the corresponding field or object gets recorded.
When applied to objects, the source of all sub-objects and sub-fields gets captured.
Furthermore, the original source of arrays gets captured and appears in synthetic source with no modifications.
          Values: `none`, `arrays`, `all`
        - `copy_to` (union oneOf)
          One of: `string[]` or `string`
        - `store` (boolean)
        - `doc_values` (union oneOf)
          - **boolean**
          - **DocValuesConfig**
            Configuration object for doc values when sub-parameters are needed.
            - `multi_value` (boolean · default: true)
              If `false`, the field is treated as single-valued, enabling optimized storage.
Only has an effect when columnar index mode is active.
            - `nullability` (boolean · default: true)
              If `false`, every document must provide a non-null value for the field: a document that
omits the field, sets it to `null`, or supplies only null values (an empty array or an
all-null array) is rejected at index time.
A field that defines `null_value` is always exempt, since the configured default removes
the absence of a value.
Only has an effect when columnar index mode is active.
        - `analyzer` (string)
        - `contexts` (object[])
          - `name` (string)
          - `path` (string)
          - `type` (string)
          - `precision` (number | string)
        - `max_input_length` (number)
        - `preserve_position_increments` (boolean)
        - `preserve_separators` (boolean)
        - `search_analyzer` (string)
      - **type: constant_keyword** (`type: constant_keyword`)
        - `type` (enum)
          Values: `constant_keyword`
        - `meta` (map string to string)
          Metadata about the field.
        - `properties` (map string to oneOf) — recursive
        - `ignore_above` (number)
        - `dynamic` (enum)
          Values: `strict`, `runtime`, `true`, `false`
        - `fields` (map string to oneOf) — recursive
        - `synthetic_source_keep` (enum)
          

Supported values include:
  - `none`: Synthetic source diverges from the original source (default)
  - `arrays`: Arrays of the corresponding field or object preserve the original element ordering and duplicate elements.
The synthetic source fragment for such arrays is not guaranteed to match the original source exactly,
e.g. array [1, 2, [5], [[4, [3]]], 5] may appear as-is or in an equivalent format like [1, 2, 5, 4, 3, 5].
The exact format may change in the future, in an effort to reduce the storage overhead of this option.
  - `all`: The source for both singleton instances and arrays of the corresponding field or object gets recorded.
When applied to objects, the source of all sub-objects and sub-fields gets captured.
Furthermore, the original source of arrays gets captured and appears in synthetic source with no modifications.
          Values: `none`, `arrays`, `all`
        - `value` (object)
      - **type: counted_keyword** (`type: counted_keyword`)
        - `type` (enum)
          Values: `counted_keyword`
        - `meta` (map string to string)
          Metadata about the field.
        - `properties` (map string to oneOf) — recursive
        - `ignore_above` (number)
        - `dynamic` (enum)
          Values: `strict`, `runtime`, `true`, `false`
        - `fields` (map string to oneOf) — recursive
        - `synthetic_source_keep` (enum)
          

Supported values include:
  - `none`: Synthetic source diverges from the original source (default)
  - `arrays`: Arrays of the corresponding field or object preserve the original element ordering and duplicate elements.
The synthetic source fragment for such arrays is not guaranteed to match the original source exactly,
e.g. array [1, 2, [5], [[4, [3]]], 5] may appear as-is or in an equivalent format like [1, 2, 5, 4, 3, 5].
The exact format may change in the future, in an effort to reduce the storage overhead of this option.
  - `all`: The source for both singleton instances and arrays of the corresponding field or object gets recorded.
When applied to objects, the source of all sub-objects and sub-fields gets captured.
Furthermore, the original source of arrays gets captured and appears in synthetic source with no modifications.
          Values: `none`, `arrays`, `all`
        - `index` (boolean)
      - **type: alias** (`type: alias`)
        - `type` (enum)
          Values: `alias`
        - `meta` (map string to string)
          Metadata about the field.
        - `properties` (map string to oneOf) — recursive
        - `ignore_above` (number)
        - `dynamic` (enum)
          Values: `strict`, `runtime`, `true`, `false`
        - `fields` (map string to oneOf) — recursive
        - `synthetic_source_keep` (enum)
          

Supported values include:
  - `none`: Synthetic source diverges from the original source (default)
  - `arrays`: Arrays of the corresponding field or object preserve the original element ordering and duplicate elements.
The synthetic source fragment for such arrays is not guaranteed to match the original source exactly,
e.g. array [1, 2, [5], [[4, [3]]], 5] may appear as-is or in an equivalent format like [1, 2, 5, 4, 3, 5].
The exact format may change in the future, in an effort to reduce the storage overhead of this option.
  - `all`: The source for both singleton instances and arrays of the corresponding field or object gets recorded.
When applied to objects, the source of all sub-objects and sub-fields gets captured.
Furthermore, the original source of arrays gets captured and appears in synthetic source with no modifications.
          Values: `none`, `arrays`, `all`
        - `path` (string)
      - **type: histogram** (`type: histogram`)
        - `type` (enum)
          Values: `histogram`
        - `meta` (map string to string)
          Metadata about the field.
        - `properties` (map string to oneOf) — recursive
        - `ignore_above` (number)
        - `dynamic` (enum)
          Values: `strict`, `runtime`, `true`, `false`
        - `fields` (map string to oneOf) — recursive
        - `synthetic_source_keep` (enum)
          

Supported values include:
  - `none`: Synthetic source diverges from the original source (default)
  - `arrays`: Arrays of the corresponding field or object preserve the original element ordering and duplicate elements.
The synthetic source fragment for such arrays is not guaranteed to match the original source exactly,
e.g. array [1, 2, [5], [[4, [3]]], 5] may appear as-is or in an equivalent format like [1, 2, 5, 4, 3, 5].
The exact format may change in the future, in an effort to reduce the storage overhead of this option.
  - `all`: The source for both singleton instances and arrays of the corresponding field or object gets recorded.
When applied to objects, the source of all sub-objects and sub-fields gets captured.
Furthermore, the original source of arrays gets captured and appears in synthetic source with no modifications.
          Values: `none`, `arrays`, `all`
        - `ignore_malformed` (boolean)
        - `time_series_metric` (enum)
          Values: `gauge`, `counter`, `summary`, `histogram`, `position`
      - **type: exponential_histogram** (`type: exponential_histogram`)
        - `type` (enum)
          Values: `exponential_histogram`
        - `meta` (map string to string)
          Metadata about the field.
        - `properties` (map string to oneOf) — recursive
        - `ignore_above` (number)
        - `dynamic` (enum)
          Values: `strict`, `runtime`, `true`, `false`
        - `fields` (map string to oneOf) — recursive
        - `synthetic_source_keep` (enum)
          

Supported values include:
  - `none`: Synthetic source diverges from the original source (default)
  - `arrays`: Arrays of the corresponding field or object preserve the original element ordering and duplicate elements.
The synthetic source fragment for such arrays is not guaranteed to match the original source exactly,
e.g. array [1, 2, [5], [[4, [3]]], 5] may appear as-is or in an equivalent format like [1, 2, 5, 4, 3, 5].
The exact format may change in the future, in an effort to reduce the storage overhead of this option.
  - `all`: The source for both singleton instances and arrays of the corresponding field or object gets recorded.
When applied to objects, the source of all sub-objects and sub-fields gets captured.
Furthermore, the original source of arrays gets captured and appears in synthetic source with no modifications.
          Values: `none`, `arrays`, `all`
        - `time_series_metric` (enum)
          Values: `gauge`, `counter`, `summary`, `histogram`, `position`
      - **type: ip** (`type: ip`)
        - `type` (enum)
          Values: `ip`
        - `meta` (map string to string)
          Metadata about the field.
        - `properties` (map string to oneOf) — recursive
        - `ignore_above` (number)
        - `dynamic` (enum)
          Values: `strict`, `runtime`, `true`, `false`
        - `fields` (map string to oneOf) — recursive
        - `synthetic_source_keep` (enum)
          

Supported values include:
  - `none`: Synthetic source diverges from the original source (default)
  - `arrays`: Arrays of the corresponding field or object preserve the original element ordering and duplicate elements.
The synthetic source fragment for such arrays is not guaranteed to match the original source exactly,
e.g. array [1, 2, [5], [[4, [3]]], 5] may appear as-is or in an equivalent format like [1, 2, 5, 4, 3, 5].
The exact format may change in the future, in an effort to reduce the storage overhead of this option.
  - `all`: The source for both singleton instances and arrays of the corresponding field or object gets recorded.
When applied to objects, the source of all sub-objects and sub-fields gets captured.
Furthermore, the original source of arrays gets captured and appears in synthetic source with no modifications.
          Values: `none`, `arrays`, `all`
        - `copy_to` (union oneOf)
          One of: `string[]` or `string`
        - `store` (boolean)
        - `doc_values` (union oneOf)
          - **boolean**
          - **DocValuesConfig**
            Configuration object for doc values when sub-parameters are needed.
            - `multi_value` (boolean · default: true)
              If `false`, the field is treated as single-valued, enabling optimized storage.
Only has an effect when columnar index mode is active.
            - `nullability` (boolean · default: true)
              If `false`, every document must provide a non-null value for the field: a document that
omits the field, sets it to `null`, or supplies only null values (an empty array or an
all-null array) is rejected at index time.
A field that defines `null_value` is always exempt, since the configured default removes
the absence of a value.
Only has an effect when columnar index mode is active.
        - `boost` (number)
        - `index` (boolean)
        - `ignore_malformed` (boolean)
        - `null_value` (string)
        - `on_script_error` (enum)
          Values: `fail`, `continue`
        - `script` (string)
        - `time_series_dimension` (boolean)
          For internal use by Elastic only. Marks the field as a time series dimension. Defaults to false.
      - **type: murmur3** (`type: murmur3`)
        - `type` (enum)
          Values: `murmur3`
        - `meta` (map string to string)
          Metadata about the field.
        - `properties` (map string to oneOf) — recursive
        - `ignore_above` (number)
        - `dynamic` (enum)
          Values: `strict`, `runtime`, `true`, `false`
        - `fields` (map string to oneOf) — recursive
        - `synthetic_source_keep` (enum)
          

Supported values include:
  - `none`: Synthetic source diverges from the original source (default)
  - `arrays`: Arrays of the corresponding field or object preserve the original element ordering and duplicate elements.
The synthetic source fragment for such arrays is not guaranteed to match the original source exactly,
e.g. array [1, 2, [5], [[4, [3]]], 5] may appear as-is or in an equivalent format like [1, 2, 5, 4, 3, 5].
The exact format may change in the future, in an effort to reduce the storage overhead of this option.
  - `all`: The source for both singleton instances and arrays of the corresponding field or object gets recorded.
When applied to objects, the source of all sub-objects and sub-fields gets captured.
Furthermore, the original source of arrays gets captured and appears in synthetic source with no modifications.
          Values: `none`, `arrays`, `all`
        - `copy_to` (union oneOf)
          One of: `string[]` or `string`
        - `store` (boolean)
        - `doc_values` (union oneOf)
          - **boolean**
          - **DocValuesConfig**
            Configuration object for doc values when sub-parameters are needed.
            - `multi_value` (boolean · default: true)
              If `false`, the field is treated as single-valued, enabling optimized storage.
Only has an effect when columnar index mode is active.
            - `nullability` (boolean · default: true)
              If `false`, every document must provide a non-null value for the field: a document that
[...]
